/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC32F7343
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *       	   	   	    ⲿж
   	   	   	   	INT0   	P00	   	P13ת
   	   	   	   	INT1   	P20	   	P14ת
   	   	   	   	INT2   	P21	   	P15ת
   	   	   	   	INT3   	P03	   	P16ת
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
   	for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0;
   	}
   	FSR0=0xFF;
   	INDF0=0;
   	for(FSR1=0;FSR1<0x7f;FSR1++) 
   	{
   	   	INDF1=0;
   	}
   	FSR1=0x7f;
   	INDF1=0; 
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
   	IOP0=0;
   	IOP1=0;
   	IOP2=0;
   	
   	OEP0=0xff; 	   	//P0  out
   	OEP1=0xff; 	   	//P1  out
   	OEP2=0xff; 	   	//P2  out 
   	
   	ADIOS0=0;
   	ADIOS1=0;
   	
   	PUP0=0;
   	PUP1=0;        	   	  
   	PUP2=0x00; 	   	   	   	   	
   	
   	PDP0=0;
   	PDP1=0;
   	PDP2=0;
}
/************************************************
;  *    @Function Name       : INT_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void INT_Init(void)
{
   	OEP0=0xF6; 	   	//P00 P03 in
   	PUP0=0x09; 	   	//P00 P03 up
   	OEP2=0xFC; 	   	//P20 P21 in
   	PUP2=0x03; 	   	//P20 P21 up

   	MCR|=0x05; 	   	//INT0/1  ½ش  23ֻ½ش
   	INT0IE=1;
   	INT1IE=1;
   	INT2IE=1;
   	INT3IE=1;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	INT_Init();
   	GIE  = 1;        
}
void main(void)
{
   	Sys_Init();
   	while(1)
   	{  	 

   	}
}

void int_isr(void)__interrupt
{
__asm
   	movra   _abuf
   	swapar  _PFLAG
   	movra   _statusbuf
__endasm;
   	if ((INT0IF) && (INT0IE)) 
   	{
   	   	P13D=!P13D;
   	   	INT0IF=0;
   	}
   	if ((INT1IF) && (INT1IE)) 
   	{
   	   	P14D=!P14D;
   	   	INT1IF=0;
   	}
   	if ((INT2IF) && (INT2IE)) 
   	{
   	   	P15D=!P15D;
   	   	INT2IF=0;
   	}
   	if ((INT3IF) && (INT3IE)) 
   	{
   	   	P16D=!P16D;
   	   	INT3IF=0;
   	}
   	
__asm
   	swapar  _statusbuf
   	movra   _PFLAG
   	swapr   _abuf
   	swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/





