/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC32F7343
;  *   	@Create Date         : 2020.05.19
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *       	   	   	  շ  4800
   	   	   	   	MCUյݣMCU͸
   	   	   	   	ʱ跢У0x0a  0x0dβ
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/
void CLR_RAM(void)
{
   	for (FSR0 = 0; FSR0 < 0xff; FSR0++)
   	{
   	   	INDF0 = 0;
   	}
   	FSR0 = 0xFF;
   	INDF0 = 0;
   	for (FSR1 = 0; FSR1 < 0x7f; FSR1++)
   	{
   	   	INDF1 = 0;
   	}
   	FSR1 = 0x7f;
   	INDF1 = 0;
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
   	IOP0 = 0;
   	IOP1 = 0;
   	IOP2 = 0;

   	OEP0 = 0xff; //
   	OEP1 = 0xff; //
   	OEP2 = 0xff; //

   	ADIOS0 = 0;
   	ADIOS1 = 0;

   	PUP0 = 0;
   	PUP1 = 0;
   	PUP2 = 0;

   	PDP0 = 0;
   	PDP1 = 0;
   	PDP2 = 0;

   	ADIOS0 = 0x00;
   	ADIOS1 = 0x00;
}
/************************************************
;  *    @Function Name       : UART_Init
;  *    @Description         :   IO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Init(void)
{
   	IOP1 |= 0x02; //IOĬϸ
   	P10OE = 0; 	  //P10in
   	P10PU = 1; 	  //P10up

   	T2CR = 0x80; //FCPU   Ƶ
   	T2LOADH = 0x00;
   	T2LOADL = 51; //Baud=FT2/(16*(T2LOAD+1))  4800

   	SCON = 0x54; //ʽ1
   	UARTIE = 1;
}
/************************************************
;  *    @Function Name       : UART_Send_Byte
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Byte(u8 dat)
{
   	REN = 0; //ֹ
   	UARTIE = 0;
   	SBUF = dat; //дݵUARTݼĴ
   	while (!TI); //ȴǰݷ
   	TI = 0;
   	REN = 1; //ʹܽ
   	UARTIE = 1;
}
/************************************************
;  *    @Function Name       : UART_Send_Data
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Data(char *s, u8 len)
{
   	while (len)
   	{
   	   	UART_Send_Byte(*s++);
   	   	len--;
   	}
}
/************************************************
;  *    @Function Name       : UART_Send_String
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_String(char *s)
{
   	while (*s) //Check the end of the string
   	{
   	   	UART_Send_Byte(*s++); //Send current char and increment string ptr
   	}
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	UART_Init();
   	GIE = 1;
}
void main(void)
{
   	u8 len;
   	u8 t;
   	Sys_Init();
   	while (1)
   	{
   	   	if (UART_RX_END_FLAG)
   	   	{
   	   	   	len = UART_RX_len; //õ˴νյݳ
   	   	   	for (t = 0; t < len; t++)
   	   	   	{
   	   	   	   	//дݵUARTݼĴ
   	   	   	   	UART_Send_Byte(UART_RX_buff[t]);
   	   	   	}
   	   	   	UART_Send_String("\r\n"); //뻻
   	   	   	UART_RX_END_FLAG = 0;
   	   	   	UART_RX_len = 0;
   	   	   	UART_RX_STA_FLAG = 0;
   	   	}
   	}
}
void int_isr(void) __interrupt
{
   	__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
   	__endasm;
   	if (UARTIF)
   	{
   	   	if (RI) //
   	   	{
   	   	   	RI = 0;

   	   	   	if (UART_RX_END_FLAG == 0)
   	   	   	{
   	   	   	   	if (UART_RX_STA_FLAG == 0)
   	   	   	   	{
   	   	   	   	   	if (SBUF == 0x0d) //
   	   	   	   	   	{
   	   	   	   	   	   	UART_RX_STA_FLAG = 1;
   	   	   	   	   	}
   	   	   	   	   	else
   	   	   	   	   	{
   	   	   	   	   	   	UART_RX_buff[UART_RX_len] = SBUF;
   	   	   	   	   	   	UART_RX_len++;
   	   	   	   	   	}
   	   	   	   	}
   	   	   	   	else
   	   	   	   	{
   	   	   	   	   	if (SBUF == 0x0a) //
   	   	   	   	   	{
   	   	   	   	   	   	UART_RX_END_FLAG = 1;
   	   	   	   	   	}
   	   	   	   	   	else
   	   	   	   	   	{
   	   	   	   	   	   	UART_RX_len = 0;
   	   	   	   	   	   	UART_RX_STA_FLAG = 0;
   	   	   	   	   	}
   	   	   	   	}
   	   	   	}
   	   	}
   	   	UARTIF = 0;
   	}
   	__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
   	__endasm;
}

/**************************** end of file *********************************************/
