/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC32F7343
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *       	   	   	   	     	   	   	   	   	   	   	   	   	   	   	   	
******************************************************************************/

#ifndef USER
#define USER

#include "MC32F7343.h"

#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define PASS 0
#define FAIL 1


u8 abuf;
u8 statusbuf;

uint8_t UART_RX_buff[20];
uint8_t UART_RX_len;

void CLR_RAM(void);
void IO_Init(void);
void UART_Init(void);
void UART_Send_Byte(u8 dat);
void UART_Send_Data(char *s, u8 len);
void UART_Send_String(char *s);
void Sys_Init(void);


//============Define  Flag=================
typedef union {
   	unsigned char byte;
   	struct
   	{
   	   	u8 bit0 : 1;
   	   	u8 bit1 : 1;
   	   	u8 bit2 : 1;
   	   	u8 bit3 : 1;
   	   	u8 bit4 : 1;
   	   	u8 bit5 : 1;
   	   	u8 bit6 : 1;
   	   	u8 bit7 : 1;
   	} bits;
}bit_flag;
volatile bit_flag flag1;

#define  	UART_RX_STA_FLAG  	flag1.bits.bit0	 
#define  	UART_RX_END_FLAG  		flag1.bits.bit1

#endif

/**************************** end of file *********************************************/

